"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from amds.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
from amds.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from pydantic import model_serializer
from typing import Any, Dict, List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class StartServerRequestBodyTypedDict(TypedDict):
    environment: NotRequired[str]
    port: NotRequired[float]
    server_request: NotRequired[str]
    stop: NotRequired[bool]


class StartServerRequestBody(BaseModel):
    environment: Optional[str] = None

    port: Optional[float] = None

    server_request: Optional[str] = None

    stop: Optional[bool] = None


class StartServerRequestTypedDict(TypedDict):
    server_name: str
    request_body: NotRequired[StartServerRequestBodyTypedDict]


class StartServerRequest(BaseModel):
    server_name: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]

    request_body: Annotated[
        Optional[StartServerRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


class StartServerResponseBodyTypedDict(TypedDict):
    r"""Start Server"""

    environment: NotRequired[str]
    hourly_rate: NotRequired[float]
    message: NotRequired[str]
    port: NotRequired[float]
    port_forward_url: NotRequired[str]
    server_name: NotRequired[str]
    server_request: NotRequired[str]
    status: NotRequired[str]
    token: NotRequired[Nullable[Any]]
    url: NotRequired[str]


class StartServerResponseBody(BaseModel):
    r"""Start Server"""

    environment: Optional[str] = None

    hourly_rate: Optional[float] = None

    message: Optional[str] = None

    port: Optional[float] = None

    port_forward_url: Optional[str] = None

    server_name: Optional[str] = None

    server_request: Optional[str] = None

    status: Optional[str] = None

    token: OptionalNullable[Any] = UNSET

    url: Optional[str] = None

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "environment",
            "hourly_rate",
            "message",
            "port",
            "port_forward_url",
            "server_name",
            "server_request",
            "status",
            "token",
            "url",
        ]
        nullable_fields = ["token"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class StartServerResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: StartServerResponseBodyTypedDict


class StartServerResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: StartServerResponseBody
